#pragma once

struct Fst;
struct Arc;

void TestFstLib(char *filename);
struct Fst *NewFst();
void FinalizeFst   (struct Fst *in);
int  AddState      (struct Fst *in);
void SetFinal      (struct Fst *in, int state);
void AddArc        (struct Fst *in, int stateFrom, int stateTo, int charFrom, int charTo);
struct Fst *Compose(struct Fst *inl, struct Fst *inr);
void Union         (struct Fst *inl, struct Fst *inr);
void Concat        (struct Fst *inl, struct Fst *inr);
void ProjectInput  (struct Fst *in);
void ProjectOutput (struct Fst *in);
struct Fst *ShortestPath(struct Fst *in);
int  WriteToFile   (struct Fst *in, char *filename);
struct Fst *ReadFromFile(char *filename);
