#pragma once

#include <caml/custom.h>
#include <caml/mlvalues.h>
#include <caml/memory.h>

#define fstValue(p) (*((struct Fst **) Data_custom_val(p)))

CAMLprim value testFstLib(value filename);
CAMLprim value newFst(value unit);
void finalizeFst(value fst);
CAMLprim value addState(value fst);
CAMLprim value setFinal(value fst, value state);
CAMLprim value addArc(value fst, value stateFrom, value stateTo, value charFrom, value charTo);
CAMLprim value compose(value fstl, value fstr);
CAMLprim value union_(value fstl, value fstr);
CAMLprim value concat(value fstl, value fstr);
CAMLprim value projectInput(value fst);
CAMLprim value projectOutput(value fst);
CAMLprim value shortestPath(value fst);
CAMLprim value writeToFile(value fst, value filename);
CAMLprim value readFromFile(value filename);
